/* @(#)ttychars.h   6.2 87/06/30 10:18:06
 *
 * <bsd/sys/ttychars.h - a la 4.xBSD for BSD to AIX porting tools
 *  derived from BSD <sys/ttychars.h>
 */
#ifndef _H_BSDtoCMS
#include <BSDtoCMS.h>
#endif
 
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *  @(#)ttychars.h  7.1 (Berkeley) 6/4/86
 */
 
/*
 * User visible structures and constants
 * related to terminal handling.
 */
#ifndef _TTYCHARS_
#define _TTYCHARS_
#ifdef BSD_COMPILE_ONLY /* AIX doesn't have BSD tty line discipline */
struct ttychars {
    char    tc_erase;   /* erase last character */
    char    tc_kill;    /* erase entire line */
    char    tc_intrc;   /* interrupt */
    char    tc_quitc;   /* quit */
    char    tc_startc;  /* start output */
    char    tc_stopc;   /* stop output */
    char    tc_eofc;    /* end-of-file */
    char    tc_brkc;    /* input delimiter (like nl) */
    char    tc_suspc;   /* stop process signal */
    char    tc_dsuspc;  /* delayed stop process signal */
    char    tc_rprntc;  /* reprint line */
    char    tc_flushc;  /* flush output (toggles) */
    char    tc_werasc;  /* word erase */
    char    tc_lnextc;  /* literal next character */
};
#endif /* BSD_COMPILE_ONLY - AIX doesn't have BSD tty line discipline\
 */
 
#define CTRL(c) ('c'&037)
 
#ifdef BSD_COMPILE_ONLY /* AIX doesn't have these, see <sys/termio.h>\
 */
/* default special characters */
#define CERASE  0177
#define CKILL   CTRL(u)
#define CINTR   CTRL(c)
#define CQUIT   034     /* FS, ^\ */
#define CSTART  CTRL(q)
#define CSTOP   CTRL(s)
#define CEOF    CTRL(d)
#define CEOT    CEOF
#define CBRK    0377
#define CSUSP   CTRL(z)
#define CDSUSP  CTRL(y)
#define CRPRNT  CTRL(r)
#define CFLUSH  CTRL(o)
#define CWERASE CTRL(w)
#define CLNEXT  CTRL(v)
#endif /* BSD_COMPILE_ONLY */
#endif
