Index: gcc/cse.c
diff -u gcc/cse.c:1.1.1.1 gcc/cse.c:1.2
--- gcc/cse.c:1.1.1.1	Wed Sep 30 11:45:12 1998
+++ gcc/cse.c	Wed Feb  3 11:46:13 1999
@@ -5819,6 +5819,10 @@
 equiv_constant (x)
      rtx x;
 {
+  /* hack alert XXX FIXME the if(0==x) test avoids a sig11 but I doubt its the right fix */
+  /* the null x value is coming from a null prev_insn_cc0 and its a mystery to me why
+   * thare seems to be a test on cc0 wheren it hasn't been set ... ?? */
+  if (0==x) return 0;
   if (GET_CODE (x) == REG
       && REGNO_QTY_VALID_P (REGNO (x))
       && qty_const[reg_qty[REGNO (x)]])
Index: gcc/config/i370/i370.h
diff -u gcc/config/i370/i370.h:1.27 gcc/config/i370/i370.h:1.30
--- gcc/config/i370/i370.h:1.27	Tue Feb  2 11:27:49 1999
+++ gcc/config/i370/i370.h	Tue Feb  2 20:45:02 1999
@@ -195,6 +195,7 @@
    R14 is the link reg. 
    R10 gets used below as the static chain reg.
    R15 hold returned values from subroutines.
+hack alert -- r10 and r15 are marked as usable???
  */
 
 #define FIXED_REGISTERS 						\
@@ -582,6 +583,13 @@
     fprintf (FILE, "\tDC\tA(PG%d)\n", i);				\
 }
 #endif /* MACROEPILOGUE */
+
+/* Output assembler code to FILE to increment profiler label # LABELNO
+   for profiling a function entry.  */
+
+#define FUNCTION_PROFILER(FILE, LABELNO) 				\
+  fprintf (FILE, "Error: No profiling available.\n")
+
 #endif /* TARGET_HLASM */
 
 
@@ -630,12 +638,6 @@
   emit_move_insn (gen_rtx (MEM, SImode, plus_constant (TRAMP, 16)), FNADDR); \
 }
 
-/* Output assembler code to FILE to increment profiler label # LABELNO
-   for profiling a function entry.  */
-
-#define FUNCTION_PROFILER(FILE, LABELNO) 				\
-  fprintf (FILE, "Error: No profiling available.\n")
-
 /* Define EXIT_IGNORE_STACK if, when returning from a function, the stack
    pointer does not matter (provided there is a frame pointer).  */
 
@@ -1543,7 +1545,7 @@
 	    strcpy (curreg, reg_names[REGNO (XV) + 1]);			\
 	else								\
 	    strcpy (curreg, reg_names[REGNO (XV)]);			\
-	fprintf (FILE, "r%s", curreg);					\
+	fprintf (FILE, "%s", curreg);					\
 	break;								\
       case MEM:								\
 	{								\
@@ -1558,9 +1560,9 @@
 	  else if (CODE == 'R')						\
 	    {								\
 	      if (GET_CODE (addr) == PLUS)				\
-		fprintf (FILE, "r%s", reg_names[REGNO (XEXP (addr, 0))]);\
+		fprintf (FILE, "%s", reg_names[REGNO (XEXP (addr, 0))]);\
 	      else							\
-		fprintf (FILE, "r%s", reg_names[REGNO (addr)]);		\
+		fprintf (FILE, "%s", reg_names[REGNO (addr)]);		\
 	    }								\
 	  else								\
 	    output_address (XEXP (XV, 0));				\
@@ -1670,7 +1672,7 @@
   switch (GET_CODE (ADDR))						\
     {									\
       case REG:								\
-	fprintf (FILE, "0(r.%s)", reg_names[REGNO (ADDR)]);		\
+	fprintf (FILE, "0(%s)", reg_names[REGNO (ADDR)]);		\
 	break;								\
       case PLUS:							\
 	breg = 0;							\
@@ -1739,10 +1741,10 @@
 	else								\
 	  fprintf (FILE, "0");						\
 	if (xreg)							\
-	    fprintf (FILE, "(r%s,r%s)",					\
+	    fprintf (FILE, "(%s,%s)",					\
 		    reg_names[REGNO (xreg)], reg_names[REGNO (breg)]); 	\
 	else								\
-	  fprintf (FILE, "(r%s)", reg_names[REGNO (breg)]);		\
+	  fprintf (FILE, "(%s)", reg_names[REGNO (breg)]);		\
 	break;								\
       default:								\
 	mvs_page_lit += 4;						\
@@ -1787,6 +1789,11 @@
 
 #define FUNCTION_PROLOGUE(FILE, LSIZE) i370_function_prolog ((FILE), (LSIZE));
 
+/* Output assembler code to FILE to increment profiler label # LABELNO
+   for profiling a function entry.  */
+/* Make it a no-op for now, so we can at least compile glibc */
+#define FUNCTION_PROFILER(FILE, LABELNO) 
+
 /* Don't bother to output .extern pseudo-ops.  They are not needed by
    ELF assemblers.  */
 
@@ -1876,14 +1883,14 @@
 
 #define ASM_OUTPUT_REG_PUSH(FILE, REGNO)				\
   mvs_check_page (FILE, 8, 4);						\
-     fprintf (FILE, "\tS\tsp,=F'4'\n\tST\tr%s,%d(sp)\n", 		\
+     fprintf (FILE, "\tS\tsp,=F'4'\n\tST\t%s,%d(sp)\n", 		\
      reg_names[REGNO], STACK_POINTER_OFFSET) 
 
 /* This is how to output an insn to pop a register from the stack.
    It need not be very fast code.  */
 #define ASM_OUTPUT_REG_POP(FILE, REGNO)					\
   mvs_check_page (FILE, 8, 0);						\
-  fprintf (FILE, "\tL\tr%s,%d(sp)\n\tLA\tsp,4(sp)\n",			\
+  fprintf (FILE, "\tL\t%s,%d(sp)\n\tLA\tsp,4(sp)\n",			\
      reg_names[REGNO], STACK_POINTER_OFFSET)
 
 
Index: gcc/config/i370/i370.md
diff -u gcc/config/i370/i370.md:1.5 gcc/config/i370/i370.md:1.7
--- gcc/config/i370/i370.md:1.5	Tue Feb  2 11:27:50 1999
+++ gcc/config/i370/i370.md	Tue Feb  2 20:45:02 1999
@@ -320,9 +320,7 @@
   if (GET_CODE (operands[1]) == MEM)
     {
       mvs_check_page (0, 6, 0);
-      /* length operand is one less than number of bytes to compare */
-      /* return \"CLC	%O0(1,%R0),%1\"; */
-      return \"CLC	%O0(0,%R0),%1\";
+      return \"CLC	%O0(1,%R0),%1\";
     }
   cc_status.flags |= CC_REVERSED;
   mvs_check_page (0, 4, 0);
@@ -495,9 +493,7 @@
 {
   check_label_emit ();
   mvs_check_page (0, 22, 0);
-  /* length operand for CLC is one less than number of bytes to compare */
-  /* return \"LA	%0,0(,1)\;CLC	%O1(%c3,%R1),%2\;BH	*+12\;BL	*+6\;SLR	%0,%0\;LNR	%0,%0\";  */
-  return \"LA	%0,0(,1)\;CLC	%O1(%c3-1,%R1),%2\;BH	*+12\;BL	*+6\;SLR	%0,%0\;LNR	%0,%0\";
+  return \"LA	%0,1\;CLC	%O1(%c3,%R1),%2\;BH	*+12\;BL	*+6\;SLR	%0,%0\;LNR	%0,%0\";
 }")
 
 ; Compare a block that is larger than 255 bytes in length.
@@ -515,7 +511,7 @@
 {
   check_label_emit ();
   mvs_check_page (0, 26, 0);
-  return \"LA	%3,%1\;LA	%4,%2\;LA	%0,0(,1)\;CLCL	%3,%4\;BH	*+12\;BL	*+6\;SLR	%0,%0\;LNR	%0,%0\";
+  return \"LA	%3,%1\;LA	%4,%2\;LA	%0,1(0,0)\;CLCL	%3,%4\;BH	*+12\;BL	*+6\;SLR	%0,%0\;LNR	%0,%0\";
 }")
 
 ;;
@@ -556,7 +552,7 @@
 	{
 	  CC_STATUS_INIT;
 	  mvs_check_page (0, 6, 0);
-	  return \"SLR	%0,%0\;LA	%N0,0(,%c1)\";
+	  return \"SLR	%0,%0\;LA	%N0,%c1(0,0)\";
 	}
       if (GET_CODE (operands[1]) == CONST_INT)
 	{
@@ -578,9 +574,7 @@
       return \"STM	%1,%N1,%0\";
     }
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(8,%R0),%1\"; */
-  return \"MVC	%O0(7,%R0),%1\";
+  return \"MVC	%O0(8,%R0),%1\";
 }")
 
 (define_insn "movdi"
@@ -613,7 +607,7 @@
 	{
 	  CC_STATUS_INIT;
 	  mvs_check_page (0, 6, 0);
-	  return \"SLR	%0,%0\;LA	%N0,0(,%c1)\";
+	  return \"SLR	%0,%0\;LA	%N0,%c1(0,0)\";
 	}
       if (GET_CODE (operands[1]) == CONST_INT)
 	{
@@ -666,7 +660,7 @@
  	  && (unsigned) INTVAL (operands[1]) < 4096)
 	{
 	  mvs_check_page (0, 4, 0);
-	  return \"LA	%0,0(,%c1)\";
+	  return \"LA	%0,%c1(0,0)\";
 	}
       mvs_check_page (0, 4, 0);
       return \"L	%0,%1\";
@@ -682,9 +676,7 @@
       return \"ST	%1,%0\";
     }
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(4,%R0),%1\"; */
-  return \"MVC	%O0(3,%R0),%1\";
+  return \"MVC	%O0(4,%R0),%1\";
 }")
 
 (define_insn "movsi"
@@ -716,7 +708,7 @@
 	  && (unsigned) INTVAL (operands[1]) < 4096)
 	{
 	  mvs_check_page (0, 4, 0);
-	  return \"LA	%0,0(,%c1)\";
+	  return \"LA	%0,%c1(0,0)\";
 	}
       mvs_check_page (0, 4, 0);
       return \"L	%0,%1\";
@@ -786,7 +778,7 @@
 	  && (unsigned) INTVAL (operands[1]) < 4096)
 	{
 	  mvs_check_page (0, 4, 0);
-	  return \"LA	%0,0(,%c1)\";
+	  return \"LA	%0,%c1(0,0)\";
 	}
       if (GET_CODE (operands[1]) == CONST_INT)
 	{
@@ -804,14 +796,10 @@
   if (GET_CODE (operands[1]) == CONST_INT)
     {
       mvs_check_page (0, 6, 0);
-      /* operand to MVC must be one less than number to move */
-      /* return \"MVC	%O0(2,%R0),%H1\"; */
-      return \"MVC	%O0(1,%R0),%H1\";
+      return \"MVC	%O0(2,%R0),%H1\";
     }
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(2,%R0),%1\"; */
-  return \"MVC	%O0(1,%R0),%1\";
+  return \"MVC	%O0(2,%R0),%1\";
 }")
 
 (define_insn "movhi"
@@ -838,7 +826,7 @@
 	  && (unsigned) INTVAL (operands[1]) < 4096)
 	{
 	  mvs_check_page (0, 4, 0);
-	  return \"LA	%0,0(,%c1)\";
+	  return \"LA	%0,%c1(0,0)\";
 	}
       if (GET_CODE (operands[1]) == CONST_INT)
 	{
@@ -882,7 +870,7 @@
   	      && (unsigned) INTVAL (operands[1]) < 4096)
 	    {
 	      mvs_check_page (0, 4, 0);
-	      return \"LA	%0,0(,%c1)\";
+	      return \"LA	%0,%c1(0,0)\";
 	    }
 	  mvs_check_page (0, 4, 0);
 	  return \"L	%0,=F'%c1'\";
@@ -901,9 +889,7 @@
       return \"MVI	%0,%B1\";
     }
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(1,%R0),%1\"; */
-  return \"MVC	%O0(0,%R0),%1\";
+  return \"MVC	%O0(1,%R0),%1\";
 }")
 
 (define_insn "movqi"
@@ -932,7 +918,7 @@
   	      && (unsigned) INTVAL (operands[1]) < 4096)
 	    {
 	      mvs_check_page (0, 4, 0);
-	      return \"LA	%0,0(,%c1)\";
+	      return \"LA	%0,%c1(0,0)\";
 	    }
 	  mvs_check_page (0, 4, 0);
 	  return \"L	%0,=F'%c1'\";
@@ -1058,9 +1044,7 @@
       return \"STM	%1,%N1,%0\";
     }
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(8,%R0),%1\"; */
-  return \"MVC	%O0(7,%R0),%1\";
+  return \"MVC	%O0(8,%R0),%1\";
 }")
 
 (define_insn "movdf"
@@ -1163,9 +1147,7 @@
       return \"ST	%1,%0\";
     }
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(4,%R0),%1\"; */
-  return \"MVC	%O0(3,%R0),%1\";
+  return \"MVC	%O0(4,%R0),%1\";
 }")
 
 (define_insn "movsf"
@@ -1286,9 +1268,7 @@
 {
   check_label_emit ();
   mvs_check_page (0, 6, 0);
-  /* operand to MVC must be one less than number to move */
-  /* return \"MVC	%O0(%c2,%R0),%1\"; */
-  return \"MVC	%O0(%c2-1,%R0),%1\";
+  return \"MVC	%O0(%c2,%R0),%1\";
 }")
 
 ; Move a block that is larger than 255 bytes in length.
@@ -1381,7 +1361,7 @@
  	  && (unsigned) INTVAL (operands[1]) < 4096)
 	{
 	  mvs_check_page (0, 4, 0);
-	  return \"LA	%0,0(,%c1)\";
+	  return \"LA	%0,%c1(0,0)\";
 	}
       if (GET_CODE (operands[1]) == CONST_INT)
 	{
@@ -1501,8 +1481,7 @@
   if (GET_CODE (operands[1]) == CONST_INT)
     {
       mvs_check_page (0, 4, 0);
-      /* LA should be safe, since %c1 is always less than 256, right?? */
-      return \"LA	%0,0(,%c1)\";
+      return \"LA	%0,%c1(0,0)\";
     }
   CC_STATUS_INIT;
   mvs_check_page (0, 8, 0);
@@ -1528,9 +1507,8 @@
     }
   if (GET_CODE (operands[1]) == CONST_INT)
     {
-      /* LA should be safe, since %c1 is always less than 256, right?? */
       mvs_check_page (0, 4, 0);
-      return \"LA	%0,0(,%c1)\";
+      return \"LA	%0,%c1(0,0)\";
     }
   CC_STATUS_INIT;
   mvs_check_page (0, 8, 0);
@@ -2870,9 +2848,7 @@
     }
   CC_STATUS_INIT;
   mvs_check_page (0, 6, 0);
-  /* length operand for XC must be one less than number of bytes to xor */
-  /* return \"XC	%O0(4,%R0),%2\"; */
-  return \"XC	%O0(3,%R0),%2\";
+  return \"XC	%O0(4,%R0),%2\";
 }")
 
 (define_insn "xorsi3"
@@ -2918,14 +2894,10 @@
   if (GET_CODE (operands[2]) == CONST_INT)
     {
       mvs_check_page (0, 6, 0);
-      /* length operand for XC must be one less than number of bytes to xor */
-      /* return \"XC	%O0(2,%R0),%H2\"; */
-      return \"XC	%O0(1,%R0),%H2\";
+      return \"XC	%O0(2,%R0),%H2\";
     }
   mvs_check_page (0, 6, 0);
-  /* length operand for XC must be one less than number of bytes to xor */
-  /* return \"XC	%O0(2,%R0),%2\"; */
-  return \"XC	%O0(1,%R0),%2\";
+  return \"XC	%O0(2,%R0),%2\";
 }")
 
 (define_insn "xorhi3"
@@ -2974,9 +2946,7 @@
       return \"XI	%0,%B2\";
     }
   mvs_check_page (0, 6, 0);
-  /* length operand for XC must be one less than number of bytes to xor */
-  /* return \"XC	%O0(1,%R0),%2\"; */
-  return \"XC	%O0(0,%R0),%2\";
+  return \"XC	%O0(1,%R0),%2\";
 }")
 
 (define_insn "xorqi3"
@@ -3166,9 +3136,7 @@
     }
   CC_STATUS_INIT;
   mvs_check_page (0, 6, 4);
-  /* length operand for XC must be one less than number of bytes to xor */
-  /* return \"XC	%O0(4,%R0),=F'-1'\"; */
-  return \"XC	%O0(3,%R0),=F'-1'\";
+  return \"XC	%O0(4,%R0),=F'-1'\";
 }")
 
 (define_insn "one_cmplsi2"
@@ -3200,9 +3168,7 @@
     }
   CC_STATUS_INIT;
   mvs_check_page (0, 6, 4);
-  /* length operand for XC must be one less than number of bytes to xor */
-  /* return \"XC	%O0(2,%R0),=X'FFFF'\"; */
-  return \"XC	%O0(1,%R0),=X'FFFF'\";
+  return \"XC	%O0(2,%R0),=X'FFFF'\";
 }")
 
 (define_insn "one_cmplhi2"
